//---------------------------------------------------------------------------
// This program demonstraits some IDE_NET features
// Compile it with ide_net_dyn.cpp support module to use with IDE_NET.DLL
// or with IDE_NET source files (e.g. in Unix env.):
// - ide_main.cpp
// - ide_netbasic.cpp
// - ide_huffman.cpp
// - ide_svinfo.cpp
// - ide_zdmaster.cpp
// - ide_threads.cpp
// - ide_external/base64.cpp
// - ide_external/inet.cpp
//---------------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#include "ide_const.h"
//#include "ide_net.h"
#include "ide_net_dyn.h"

const char *GameName[GM_NUMB]={"Odamex","ZDaemon","Skulltag"};

//==========set game here:
//#define GAME GM_ODAMEX
#define GAME GM_ZDAEMON
//#define GAME GM_SKULLTAG
//---------------------------------------------------------------------------
void Pause(char* s)
{
    printf("__________________________\n%s\n",s);
    printf("press Enter to continue...\n\n");
    getchar();
}
//---------------------------------------------------------------------------
int main()
{
    int i;

// init ================================
    if(!Load_IDE_Net_DLL())
    {
        printf("Cant load IDE_NET.DLL\n");
        exit(0);
    }

    i=IDE_GetVersion();
    printf("IDE Version=%d.%d\n",i/100,i%100);

//=== set port if need it:
//    IDE_SetLocalPort(2000);

    if(!IDE_Init())
    {
        char s[256]={0};
        IDE_GetWarningMessage(s);
        printf("Cant initialize IDE_NET, error: %s\n",s);
        exit(0);
    }

// query defined GAME Master Server ==========
	printf("\nSelected Game: %s\n",GameName[GAME]);
	Pause("Query Master Server");
    int n=IDE_GetMasterList(GAME);
    if(n<0)
    {
        printf("Cant connect to %s master server\n",GameName[GAME]);
        exit(0);
    }
    else
        printf("Number of %s servers=%d\n",GameName[GAME],n);

// now query all server ====================
    Pause("Now get info from all servers in the list");

	int svnumb=n;
    ServerData **svi=new ServerData*[svnumb];
    char sv[MAXADR+1];
    for(int i=0;i<svnumb;++i)
    {
        IDE_GetMasterListServer(i,sv);
        svi[i]=new ServerData;
        strcpy(svi[i]->address,sv);
        svi[i]->gmflag=GAME;
    }

    time_t t1=time(NULL);
    IDE_GetServerGroup(svi,svnumb,-1,-1);
    time_t t2=time(NULL);

    int iyes=0,ino=0,iignor=0;
    for(int i=0;i<svnumb;++i)
    {
        if(  svi[i]->result==SVMSG_OK
          || svi[i]->result==SVMSG_ST_BAN
          || svi[i]->result==SVMSG_ST_IGNORE)
            iyes++;
        else
            ino++;
        if(svi[i]->result==SVMSG_ST_IGNORE)
            iignor++;
    }

    printf("Group server result:\n");
    printf("refresh time=%d sec\n",(int)(t2-t1));
    printf("full number of servers=%d\n",svnumb);
    printf("answered=%d  (ignored=%d)\n",iyes,iignor);
    printf("not answered=%d\n",ino);

    if(iyes-iignor>0)
    {
        printf("\nfirst answered server:\n");
	    int i1=0;
        while(svi[i1]->result != SVMSG_OK) i1++;
        printf("adr=%-22s  name=%s\n",svi[i1]->address,svi[i1]->hostname);
    }

    for(int i=0;i<svnumb;++i) delete svi[i];
    delete[] svi;

// the End =============================
    Pause("\nEasy? ;-)");
    IDE_Close();
    Free_IDE_Net_DLL();
    return 0;
}
//---------------------------------------------------------------------------
